import { Configuration } from '@energyweb/utils-general';
import { PreciseProofs } from 'precise-proofs-js';
import { IOwnershipCommitmentProof, IOwnershipCommitment, CommitmentStatus, OwnershipCommitmentProofWithTx } from '@energyweb/origin-backend-core';
export interface IOnChainProperties {
    propertiesDocumentHash: string;
}
export declare abstract class PreciseProofEntity implements IOnChainProperties {
    id: number;
    configuration: Configuration.Entity;
    proofs: PreciseProofs.Proof[];
    propertiesDocumentHash: string;
    constructor(id: number, configuration: Configuration.Entity);
    get certificateClient(): import("@energyweb/origin-backend-client").ICertificateClient;
    saveCommitment(proof: OwnershipCommitmentProofWithTx): Promise<CommitmentStatus>;
    getCommitment(): Promise<OwnershipCommitmentProofWithTx>;
    getPendingTransferCommitment(): Promise<OwnershipCommitmentProofWithTx>;
    verifyOffChainProperties(rootHash: string, properties: any): void;
    abstract sync(): Promise<PreciseProofEntity>;
    generateAndAddProofs(commitment: IOwnershipCommitment, salts?: string[]): IOwnershipCommitmentProof;
    private addProof;
}
